/*******************************************************************************
 *	@file			TestDXLibv2.cpp
 *	@brief			DirectX Test Program
 *
 *	@date			08-Apr-2009(Wed)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DL.h"
#pragma comment ( lib, "_DXLibv2.lib" )

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumDisplay
 *	@brief		ʃTCY
 ******************************************************************************/
enum enumDisplay
{
	enumDisplay_640x480		= 0,												//!<  VGA( 640x 480)
	enumDisplay_800x600,														//!< SVGA( 800x 600)
	enumDisplay_1024x768,														//!<  XGA(1024x 768)
	enumDisplay_FullScreen,														//!< tXN[

	enumDisplay_Max,
};

// O[oϐ---------------------------------------------------------
static const char* const APPNAME	= "TESTDXLIBV2";							//!< Av̖O
static const int APPWIDTH			= 800;										//!< Av̏
static const int APPHEIGHT			= 600;										//!< Av̏

HANDLE	g_hMutex = NULL;														//!< Lnh
HWND	g_hWnd = NULL;															//!< EChEnh

DL::SDLParam g_SDL;																//!< p[^
enumDisplay g_eDisp = enumDisplay_800x600;										//!< \

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			EChEvV[W
 ******************************************************************************/
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_F2:																//!< F2L[
			if( g_SDL.m_hWnd != NULL )
			{
				switch( g_eDisp )
				{
				case enumDisplay_800x600:										//!< 800x600 -> tXN[
					{
						g_SDL.m_nWidth	= ::GetSystemMetrics( SM_CXSCREEN );
						g_SDL.m_nHeight	= ::GetSystemMetrics( SM_CYSCREEN );
						g_SDL.m_bMode	= FALSE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						g_eDisp = enumDisplay_FullScreen;
					}
					break;
				case enumDisplay_1024x768:										//!< 1024x768 -> 800x600
					{
						g_SDL.m_nWidth	= 800;
						g_SDL.m_nHeight	= 600;
						g_SDL.m_bMode	= TRUE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - g_SDL.m_nWidth ) / 2;;
						int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - g_SDL.m_nHeight ) / 2;;
						::MoveWindow( g_SDL.m_hWnd, nPosX, nPosY, g_SDL.m_nWidth, g_SDL.m_nHeight, TRUE );

						g_eDisp = enumDisplay_800x600;
					}
					break;
				case enumDisplay_FullScreen:									//!< tXN[ -> 1024x768
					{
						g_SDL.m_nWidth	= 1024;
						g_SDL.m_nHeight	= 768;
						g_SDL.m_bMode	= TRUE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - g_SDL.m_nWidth ) / 2;;
						int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - g_SDL.m_nHeight ) / 2;;
						::MoveWindow( g_SDL.m_hWnd, nPosX, nPosY, g_SDL.m_nWidth, g_SDL.m_nHeight, TRUE );

						g_eDisp = enumDisplay_1024x768;
					}
					break;
				}
			}
			break;
		case VK_ESCAPE:															//!< ESCL[
			::DestroyWindow( hWnd );
			break;
		}
		break;
	case WM_DESTROY:															//!< EChE
		::PostQuitMessage( 0 );													//!< WM_QUIT𑗂
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	default :
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	}
	return ::DefWindowProc( hWnd, msg, wParam, lParam );
}

/*******************************************************************************
 *	@fn				int Init( const HINSTANCE& hInst )
 *	@param[in]		hInst			CX^Xnh
 *	@retval			int			
 *	@brief			AvP[V̏
 ******************************************************************************/
int Init( const HINSTANCE& hInst )
{
	// dŇ
	// L̊m
	g_hMutex = ::CreateMutex( NULL, FALSE, APPNAME );
	// Ľ
	if( ::WaitForSingleObject( g_hMutex, 0 ) != WAIT_OBJECT_0 )
	{
		_ASSERT( 0 && "WaitForSingleObject()" );
		::CloseHandle( g_hMutex );
		return EXIT_FAILURE;
	}

	// EChE
	WNDCLASS			wc;														//!< EChENX
	// EChENX̓o^
	wc.style				= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc			= static_cast<WNDPROC>( WndProc );					//!< bZ[W󂯎EChE֐
	wc.cbClsExtra			= 0;
	wc.cbWndExtra			= 0;
	wc.hInstance			= hInst;
	wc.hIcon				= NULL;												//!< ACRo^
	wc.hCursor				= ::LoadCursor( NULL, IDC_ARROW );					//!< J[\o^
	wc.hbrBackground		= static_cast<HBRUSH>( ::GetStockObject( WHITE_BRUSH ) );
	wc.lpszMenuName			= NULL;												//!< j[̓o^
	wc.lpszClassName		= APPNAME;
	// EChENX̓o^
	if( !::RegisterClass( &wc ) ) return EXIT_FAILURE;

	int nSizeX = APPWIDTH;
	int nSizeY = APPHEIGHT;
	int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - nSizeX ) / 2;;
	int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - nSizeY ) / 2;;
	// EChE쐬
	g_hWnd = ::CreateWindow( APPNAME,											//!< NX
							 APPNAME,											//!< ^Cg
							 WS_POPUP,											//!< X^C
							 nPosX,												//!< wW
							 nPosY,												//!< xW
							 nSizeX,											//!< 
							 nSizeY,											//!< 
							 NULL,												//!< eEChẼnh
							 NULL,												//!< j[nh
							 hInst,												//!< CX^Xnh
							 NULL );											//!< lParam

	// EChE̍쐬
	if( !g_hWnd ) return EXIT_FAILURE;
	// EChE̕\Ԃ̐ݒ
	::ShowWindow( g_hWnd, SW_SHOW );
	// EChE̍XV
	::UpdateWindow( g_hWnd );

	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				int Exit( void )
 *	@retval			int			
 *	@brief			AvP[V̏I
 ******************************************************************************/
int Exit( void )
{
	if( g_hWnd != NULL ) { ::DestroyWindow( g_hWnd ); g_hWnd = NULL; }
	if( g_hMutex != NULL ) { ::CloseHandle( g_hMutex ); g_hMutex = NULL; }
	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				BOOL ProcessEvent( void )
 *	@retval			int			
 *	@brief			Cxg̎s
 ******************************************************************************/
BOOL ProcessEvent( void )
{
	MSG	msg;
	// botLPOOŎgpBɂ̃AvŗDŎgp
	while( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
	{
		if( !::GetMessage( &msg, NULL, 0, 0 ) )
			return FALSE;
		::TranslateMessage( &msg );
		::DispatchMessage( &msg );
	}
	return TRUE;
}

/*******************************************************************************
 *	@fn				int WINAPI WinMain( HINSTANCE hInstance,
 *									    HINSTANCE hPrevInstance,
 *										LPSTR lpCmdLine,
 *										int nCmdShow )
 *	@param[in]		hInstance		CX^Xnh
 *	@param[in]		hPrevInstance	CX^Xnh
 *	@param[in]		lpCmdLine		
 *	@param[in]		nCmdShow		
 *	@retval			LRESULT			
 *	@brief			vON
 ******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance,
				    HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow )
{
	// AvP[V̏
	if( Init( hInstance ) == EXIT_FAILURE ) return EXIT_FAILURE;

	// p[^̏
	g_SDL.m_hWnd	= g_hWnd;
	g_SDL.m_nWidth	= APPWIDTH;
	g_SDL.m_nHeight	= APPHEIGHT;
	g_SDL.m_bMode	= TRUE;
	// DirectX Library ̏
	if( !DL::Init( g_SDL ) ) goto ERR_EXIT;

	// [v
	do
	{
		// s
		DL::Exec();
	} while( ProcessEvent() );

ERR_EXIT:
	// DirectX Library ̏I
	DL::Exit();
	// AvP[V̏I
	Exit();

	return EXIT_SUCCESS;
}
